import { OpenSheetMusicDisplay, Instrument, Voice } from "opensheetmusicdisplay";
declare enum PlaybackState {
    INIT = "INIT",
    PLAYING = "PLAYING",
    STOPPED = "STOPPED",
    PAUSED = "PAUSED"
}
interface PlaybackSettings {
    bpm: number;
    masterVolume: number;
}
export default class PlaybackEngine {
    private ac;
    private defaultBpm;
    private cursor;
    private sheet;
    private denominator;
    private scheduler;
    private instrumentPlayer;
    private iterationSteps;
    private currentIterationStep;
    private timeoutHandles;
    playbackSettings: PlaybackSettings;
    state: PlaybackState;
    availableInstruments: [number, string][];
    scoreInstruments: Instrument[];
    ready: boolean;
    constructor();
    get wholeNoteLength(): number;
    getPlaybackInstrument(voiceId: number): [number, string];
    setInstrument(voice: Voice, midiInstrumentId: number): Promise<void>;
    loadScore(osmd: OpenSheetMusicDisplay): Promise<void>;
    private initInstruments;
    private loadInstruments;
    play(): Promise<void>;
    stop(): Promise<void>;
    pause(): void;
    jumpToStep(step: any): void;
    setBpm(bpm: number): void;
    private countAndSetIterationSteps;
    private notePlaybackCallback;
    private stopPlayers;
    private clearTimeouts;
    private iterationCallback;
}
export {};
